<!--
 - Copyright (C) 2004, 2005 Internet Systems Consortium, Inc. ("ISC")
 - Copyright (C) 2000, 2001 Internet Software Consortium.
 - 
 - Permission to use, copy, modify, and distribute this software for any
 - purpose with or without fee is hereby granted, provided that the above
 - copyright notice and this permission notice appear in all copies.
 - 
 - THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES WITH
 - REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 - AND FITNESS. IN NO EVENT SHALL ISC BE LIABLE FOR ANY SPECIAL, DIRECT,
 - INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 - LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 - OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 - PERFORMANCE OF THIS SOFTWARE.
-->
<!-- $Id: rndc.html,v 1.7.2.1.4.12 2006/06/29 13:02:31 marka Exp $ -->
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>rndc</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.70.1">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="refentry" lang="en">
<a name="id2482688"></a><div class="titlepage"></div>
<div class="refnamediv">
<h2>Name</h2>
<p><span class="application">rndc</span> &#8212; name server control utility</p>
</div>
<div class="refsynopsisdiv">
<h2>Synopsis</h2>
<div class="cmdsynopsis"><p><code class="command">rndc</code>  [<code class="option">-c <em class="replaceable"><code>config-file</code></em></code>] [<code class="option">-k <em class="replaceable"><code>key-file</code></em></code>] [<code class="option">-s <em class="replaceable"><code>server</code></em></code>] [<code class="option">-p <em class="replaceable"><code>port</code></em></code>] [<code class="option">-V</code>] [<code class="option">-y <em class="replaceable"><code>key_id</code></em></code>] {command}</p></div>
</div>
<div class="refsect1" lang="en">
<a name="id2549451"></a><h2>DESCRIPTION</h2>
<p>
        <span><strong class="command">rndc</strong></span> controls the operation of a name
	server.  It supersedes the <span><strong class="command">ndc</strong></span> utility
	that was provided in old BIND releases.  If
	<span><strong class="command">rndc</strong></span> is invoked with no command line
	options or arguments, it prints a short summary of the
	supported commands and the available options and their
	arguments.
    </p>
<p>
        <span><strong class="command">rndc</strong></span> communicates with the name server
	over a TCP connection, sending commands authenticated with
	digital signatures.  In the current versions of
	<span><strong class="command">rndc</strong></span> and <span><strong class="command">named</strong></span> named
        the only supported authentication algorithm is HMAC-MD5,
	which uses a shared secret on each end of the connection.
	This provides TSIG-style authentication for the command
	request and the name server's response.  All commands sent
	over the channel must be signed by a key_id known to the
	server.
    </p>
<p>
        <span><strong class="command">rndc</strong></span> reads a configuration file to
	determine how to contact the name server and decide what
	algorithm and key it should use.
    </p>
</div>
<div class="refsect1" lang="en">
<a name="id2549492"></a><h2>OPTIONS</h2>
<div class="variablelist"><dl>
<dt><span class="term">-c <em class="replaceable"><code>config-file</code></em></span></dt>
<dd><p>
	      Use <em class="replaceable"><code>config-file</code></em>
	      as the configuration file instead of the default,
	      <code class="filename">/etc/rndc.conf</code>.
	  </p></dd>
<dt><span class="term">-k <em class="replaceable"><code>key-file</code></em></span></dt>
<dd><p>
	      Use <em class="replaceable"><code>key-file</code></em>
	      as the key file instead of the default,
	      <code class="filename">/etc/rndc.key</code>.  The key in
	      <code class="filename">/etc/rndc.key</code> will be used to authenticate
	      commands sent to the server if the <em class="replaceable"><code>config-file</code></em>
	      does not exist.
	  </p></dd>
<dt><span class="term">-s <em class="replaceable"><code>server</code></em></span></dt>
<dd><p>
	       <em class="replaceable"><code>server</code></em> is
	       the name or address of the server which matches a
	       server statement in the configuration file for
	       <span><strong class="command">rndc</strong></span>.  If no server is supplied on the
	       command line, the host named by the default-server clause
	       in the option statement of the configuration file will be
	       used.
	  </p></dd>
<dt><span class="term">-p <em class="replaceable"><code>port</code></em></span></dt>
<dd><p>
	       Send commands to TCP port
	       <em class="replaceable"><code>port</code></em> instead
	       of BIND 9's default control channel port, 953.
	  </p></dd>
<dt><span class="term">-V</span></dt>
<dd><p>
	       Enable verbose logging.
	  </p></dd>
<dt><span class="term">-y <em class="replaceable"><code>keyid</code></em></span></dt>
<dd><p>
	       Use the key <em class="replaceable"><code>keyid</code></em>
	       from the configuration file.
	       <em class="replaceable"><code>keyid</code></em> must be
	       known by named with the same algorithm and secret string
	       in order for control message validation to succeed.
	       If no <em class="replaceable"><code>keyid</code></em>
	       is specified, <span><strong class="command">rndc</strong></span> will first look
	       for a key clause in the server statement of the server
	       being used, or if no server statement is present for that
	       host, then the default-key clause of the options statement.
	       Note that the configuration file contains shared secrets
	       which are used to send authenticated control commands
	       to name servers.  It should therefore not have general read
	       or write access.
	  </p></dd>
</dl></div>
<p>
      For the complete set of commands supported by <span><strong class="command">rndc</strong></span>,
      see the BIND 9 Administrator Reference Manual or run
      <span><strong class="command">rndc</strong></span> without arguments to see its help message.
    </p>
</div>
<div class="refsect1" lang="en">
<a name="id2549811"></a><h2>LIMITATIONS</h2>
<p>
        <span><strong class="command">rndc</strong></span> does not yet support all the commands of
	the BIND 8 <span><strong class="command">ndc</strong></span> utility.
    </p>
<p>
        There is currently no way to provide the shared secret for a
        <code class="option">key_id</code> without using the configuration file.
    </p>
<p>
        Several error messages could be clearer.
    </p>
</div>
<div class="refsect1" lang="en">
<a name="id2549840"></a><h2>SEE ALSO</h2>
<p>
      <span class="citerefentry"><span class="refentrytitle">rndc.conf</span>(5)</span>,
      <span class="citerefentry"><span class="refentrytitle">named</span>(8)</span>,
      <span class="citerefentry"><span class="refentrytitle">named.conf</span>(5)</span>
      <span class="citerefentry"><span class="refentrytitle">ndc</span>(8)</span>,
      <em class="citetitle">BIND 9 Administrator Reference Manual</em>.
    </p>
</div>
<div class="refsect1" lang="en">
<a name="id2549892"></a><h2>AUTHOR</h2>
<p>
        <span class="corpauthor">Internet Systems Consortium</span>
    </p>
</div>
</div></body>
</html>
